package ve.gob.cenditel.tibisaymovil;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;

import javax.net.ssl.HttpsURLConnection;


import ee.sk.digidoc.DataFile;
import ee.sk.digidoc.DigiDocException;
import ee.sk.digidoc.Signature;
import ee.sk.digidoc.SignedDoc;
import ee.sk.digidoc.factory.DigiDocFactory;
import ee.sk.utils.ConfigManager;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Environment;
import android.os.Looper;
import android.app.Activity;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.View.OnClickListener;
import android.webkit.MimeTypeMap;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class BDOCVerifyResultActivity extends Activity {

	
   
	
	// linear
	private LinearLayout button_share;
    private LinearLayout button_finish;
    private ListView documents_list;
    private ImageView arrowShowErrors;
    
    // cadena que mantiene la ruta para almacenar los archivos
    // extraidos de un contendor BDOC
    private String extractedDirFiles;
    
    // ruta absoluta al archivo a verificar
    private String fileToVerify;
    
    // extension del archivo a verificar
    private String fileToVerifyExtension;

    
    // mimetype del archivo a verificar
    private String mimeTypeFileToVerify;
	
    
    private ArrayList<SignatureErrorDetail> errorList;
    
	// Progress Dialog
    private ProgressDialog pDialog;
    
    // Progress dialog type (0 - for Horizontal progress bar)
    public static final int progress_bar_type = 0;
    
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		
		//Estilando la barra de titulo
		final boolean customTitleSupported = requestWindowFeature(Window.FEATURE_CUSTOM_TITLE);
		Log.d("onCreate", "antes de super");
		super.onCreate(savedInstanceState);		
		
		setContentView(R.layout.activity_verify_result_bdoc);
		
		//Estilando Barra de titulo
		if(customTitleSupported)
			getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.title_bar);
		
		arrowShowErrors = (ImageView) this.findViewById(R.id.arrow_show_errors);
		arrowShowErrors.setVisibility(ImageView.GONE);
		
		button_share = (LinearLayout) this.findViewById(R.id.button_share_zone);
        button_finish = (LinearLayout) this.findViewById(R.id.button_finish_zone);
        
        // inicializa la lista de objetos de errores de firma
		errorList = new ArrayList<SignatureErrorDetail>();
        
		
		// habilita el click sobre la acción de finalizar la verificacion de firma y regresar
        button_finish.setOnClickListener(new OnClickListener() 
        {        
            public void onClick(View v) 
            {
            	
            	Intent oIntent = new Intent(BDOCVerifyResultActivity.this, TibisayMovilActivity.class);
		        oIntent.setAction(Intent.ACTION_VIEW);
		        oIntent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
		        startActivity(oIntent);
		        
		        finish();
            }
        });

        // habilita el click sobre la acción de compartir el archivo
        button_share.setOnClickListener(new OnClickListener() 
        {        
            public void onClick(View v) 
            {
            	shareIt();
            }
        });
        
        // habilita el click sobre la flecha para mostrar los errores de la firma
        arrowShowErrors.setOnClickListener(new OnClickListener(){

			public void onClick(View arg0) {
			
				Intent intent = new Intent(BDOCVerifyResultActivity.this, ActivitySignatureErrors.class);
				
				
								
				intent.setClass(BDOCVerifyResultActivity.this, ActivitySignatureErrors.class);
				intent.putExtra("SignatureErrorDetailList", errorList);
				intent.putExtra("numeroObjetoError", Integer.toString(errorList.size()));
				
				startActivity(intent);
				
			}
        	
        });
		
        // chequear si intent tiene data
        final android.content.Intent intent = getIntent();

        final Bundle bundle = getIntent().getExtras();
        
	      if (intent != null) {
	    	  Toast.makeText(getApplicationContext(), "intent != null", Toast.LENGTH_SHORT).show();

	    	  final android.net.Uri data = intent.getData ();
	    	  
		      if (data != null) {
		    	  Toast.makeText(getApplicationContext(), "data != null", Toast.LENGTH_SHORT).show();
		    	  
		    	  // verificar el tipo de scheme
		    	  String scheme = data.getScheme();
		            
		          // verificacion de un archivo que esta en el dispositivo 
		          if (scheme.equals("file")) {
		        	  Toast.makeText(getApplicationContext(), "file: "+data.getPath(), Toast.LENGTH_SHORT).show();
		        	  
		        	  // verificar el archivo
		        	  if (data.getPath().endsWith("bdoc")){
		        		  fileToVerify = data.getPath();
		        		  
		        		  // ejecutar la verificacion	        
		        		  doBdocVerification(data.getPath());
						}else{
							Toast.makeText(getApplicationContext(), "¡Por Implementar!", Toast.LENGTH_SHORT).show();
							
						}
			          
		          }
		           
		          // verificacion de un archivo que se debe descargar
		          if (scheme.equals("https")) {
		        	  Toast.makeText(getApplicationContext(), "scheme: "+data.toString(), Toast.LENGTH_SHORT).show();
		        	  
		        	  Toast.makeText(getApplicationContext(), "externalStorage: "+Environment.getExternalStorageDirectory().toString(), Toast.LENGTH_SHORT).show();
		        	  
		        	  
		        	  new DownloadFileFromURL().execute(data.toString());
		        	  //new DownloadFileFromURL().execute("http://farm1.static.flickr.com/114/298125983_0e4bf66782_b.jpg");
		        	  
		        	  //Toast.makeText(getApplicationContext(), "****despues de execute()", Toast.LENGTH_SHORT).show();
		        	  // verificar el archivo
		          }
		    	  
		    	  
		    	  return;
		      }
		      
		      // verificacion de archivo desde la Activity principal
		      if (bundle != null) {
		    	fileToVerify = bundle.getString("fileToVerify");
		    	fileToVerifyExtension = bundle.getString("fileExtension"); 
		    	mimeTypeFileToVerify = getMimeType(fileToVerify);
		    			
		    	Toast.makeText(getApplicationContext(), "fileToVerify: "+fileToVerify, Toast.LENGTH_SHORT).show();
		    	
		    	if (fileToVerifyExtension.equals("bdoc")){
					// ejecutar la verificacion	        
					doBdocVerification(fileToVerify);
				}else{
					Toast.makeText(getApplicationContext(), "¡Por Implementar!", Toast.LENGTH_SHORT).show();
					
				}
		    	
		    	//return;
		      }
		        	 
	      }else{
	    	  Toast.makeText(getApplicationContext(), "intent == null", Toast.LENGTH_SHORT).show();
	      }
        
        
	    //Bundle bundle=getIntent().getExtras();
		//fileToVerify = bundle.getString("fileToVerify");
		//fileToVerifyExtension = bundle.getString("fileExtension"); 
		//mimeTypeFileToVerify = getMimeType(fileToVerify);
		//Toast.makeText(getApplicationContext(), "fileToVerify: "+fileToVerify, Toast.LENGTH_SHORT).show();
		
		
		/*		
		if (fileToVerifyExtension.equals("bdoc")){
			// ejecutar la verificacion	        
			doBdocVerification(fileToVerify);
		}else{
			Toast.makeText(getApplicationContext(), "¡Por Implementar!", Toast.LENGTH_SHORT).show();
			
		}
		*/
		
		
        
	}
	
	
	
	
	
	@Override
	public void onStart () {
		
		android.util.Log.d ("**onStart(): ", " onStart");
		super.onStart ();
		
		
		final android.content.Intent intent = getIntent ();
		
		if (intent != null)
	      {
	         android.util.Log.d ("**onStart(): ", "> Got intent : " + intent);

	         final android.net.Uri data = intent.getData ();

	         if (data != null)
	         {
	            android.util.Log.d ("**onStart(): ", "> Got data   : " + data);

	            final String filePath = data.getEncodedPath ();

	            android.util.Log.d ("**onStart(): ", "> Open file  : " + filePath);

	            // file loading comes here.
	         } // if
	      } // if
	      android.util.Log.d ("**onStart(): ", "- saliendo onStart");
	      return;
	
	}
	
	
	
	// funcion para verificar un documento
	private void doBdocVerification(String absolutePathFileToVerify){
		
		try {
			Log.d("doBdocVerification:", "Inicializando jdigidoc ...");
	    	ConfigManager.init("jar://jdigidoc.cfg");
			Log.d("despues de:", "ConfigManager.init");
			
			Log.d("antes de:", "digFac");
			DigiDocFactory digFac = ConfigManager.instance().getDigiDocFactory();
			
			Log.d("getFilesDir:", getFilesDir().getAbsolutePath());
			
			Log.d("PATH", Environment.getExternalStorageDirectory().toString());
			
			File file = new File(absolutePathFileToVerify);
        	InputStream selectedFile = null;
        	selectedFile = new BufferedInputStream(new FileInputStream(file));
			
        	SignedDoc sdoc = digFac.readSignedDocFromStreamOfType(selectedFile, true);		    
        	selectedFile.close();
		    
        	//SignedDoc sdoc = digFac.readSignedDocFromStreamOfType(fraw, true);		    
		    Signature signature = sdoc.getSignature(0);
		    	
		    // TextView para colocar el resultado de la firma
		    TextView signatureVerificationResult = (TextView) findViewById(R.id.archivo_para_firmar_path);
		    
		    
		    // array de excepciones lanzadas al verificar firmas
		    ArrayList arraySignaturesErrors = null;
		        
		    // verificar cada una de las firmas del contenedor
		    for (int i = 0; i < sdoc.countSignatures(); i++){
		    	Signature tmpSignature = sdoc.getSignature(i);
		    	arraySignaturesErrors = new ArrayList();
		    	arraySignaturesErrors = tmpSignature.verify(sdoc, false, false);
		    	Log.d("**La Firma: "+Integer.toString(i),"tiene : "+ arraySignaturesErrors.size()+" errores.");		    	
		    	
		    	// lista de cadenas que almancenara los errores para el firmante i
		    	ArrayList<String> signatureVerificationErrors = new ArrayList<String>();		    	
		    	
		    	for (int j = 0; j < arraySignaturesErrors.size(); j++){	
		    		// agregar la cadena de error particular a la lista
		    		signatureVerificationErrors.add(arraySignaturesErrors.get(j).toString() + "\n");
		    	}
		    	
		    	//String cn = SignedDoc.getCommonName(sdoc.getSignature(i).getKeyInfo().getSignersCertificate().getSubjectDN().getName());
		    	String signer = sdoc.getSignature(i).getKeyInfo().getSubjectLastName();
		    	
		    	// crear objeto SignatureErrorDetail con detalles de error para la firma i 
		    	SignatureErrorDetail object = new SignatureErrorDetail(signer, signatureVerificationErrors);
		    	
		    	// agregar el objeto SignatureErrorDetail a lista
		    	errorList.add(object);
		    	
		    } // fin del for para la firma i
		    
		    if (arraySignaturesErrors.isEmpty()) {
		    	signatureVerificationResult.setText(getResources().getString(R.string.string_valid_signature));
		    	Log.d("signature.verify", "NO HUBO ERROR EN LA VERIFICACION DE FIRMA");
		    	Toast.makeText(getApplicationContext(), "¡FIRMA CORRECTA!", Toast.LENGTH_SHORT).show();
		    	
		    }else{
		    	
		    	// habilitar la flecha para mostrar los errores de firma
		    	arrowShowErrors.setVisibility(ImageView.VISIBLE);
		    	
		    	//signatureVerificationResult.setText("Inválida.");
		    	signatureVerificationResult.setText(getResources().getString(R.string.string_invalid_signature));
		    	Log.d("************", "SI HUBO ERROR");
		    	
		    	Toast.makeText(getApplicationContext(), "ERROR DE VERIFICACION DE FIRMA", Toast.LENGTH_SHORT).show();
		    }
		    
		    
		    //ArrayList sigError = signature.verify(sdoc, false, false);
		    //ArrayList sigError = sdoc.verify(false, false);
		    
		    // se crea el adaptador para mostrar los documentos firmados
		    ListView documentListView = (ListView) findViewById(R.id.documents_list);
			final ArrayList<DocumentFromBDOC> docs = new ArrayList<DocumentFromBDOC>();
			
			// Crear directorio ExtractedFiles donde se almacenan los archivos extraidos
			// de los contenedores BDOC
			extractedDirFiles = Environment.getExternalStorageDirectory() + "/" +
  			getResources().getString(R.string.app_name) + "/" +
  			getResources().getString(R.string.extracted_dir_files) + "/";			
			prepareDirectory();
			
			for (int i = 0; i < sdoc.countDataFiles(); i++){
		    	// obtener el DataFile
				DataFile df = sdoc.getDataFile(i);
		    	docs.add(new DocumentFromBDOC(df.getFileName()));
		    	Log.d("MIMETYPE:", df.getMimeType());
		    	// Extraer el archivo y guardarlo en /mnt/sdcard/TibisayMovil/ExtractedFiles
		    	FileOutputStream fos = new FileOutputStream(extractedDirFiles+df.getFileName());
		    	InputStream is = df.getBodyAsStream();
		    	if(is == null) {
                    Log.d("ERROR al extrarer archivo", "DataFile has no data!");
                    //return false;
		    	}
		    	byte[] data = new byte[4096];
		    	int n = 0, m = 0;
		    	while((n = is.read(data)) > 0) {
		    		fos.write(data, 0, n);
                    m += n;
		    	}
		    	fos.close();
		    	is.close();		    	
		    }
			
			DocumentFromBDOCAdapter documentAdapter = new DocumentFromBDOCAdapter(BDOCVerifyResultActivity.this, docs);
			documentListView.setAdapter(documentAdapter);
			documentListView.setOnItemClickListener(new android.widget.AdapterView.OnItemClickListener() {

				@Override
				public void onItemClick(AdapterView<?> parent, View view,
						int position, long id) {
					String absolutePathToOpen = extractedDirFiles + docs.get(position).getName();
					Toast.makeText(getApplicationContext(), getMimeType(absolutePathToOpen), Toast.LENGTH_SHORT).show();
					openIt(absolutePathToOpen, getMimeType(absolutePathToOpen));
					
					
				}
				
			});
			
			// se crea el adaptador para mostrar los firmantes del contenedor
			ListView signerListView = (ListView) findViewById(R.id.signatures_list);
			final ArrayList<SignerFromBDOC> signers = new ArrayList<SignerFromBDOC>();
			
		    for (int i = 0; i < sdoc.countSignatures(); i++){	    	
		    	Signature signatureTemp = sdoc.getSignature(i);
		    	//signers.add(new SignerFromBDOC(signatureTemp.getSubject()));
		    	
		    	String cn = SignedDoc.getCommonName(
		    			sdoc.getSignature(i).getKeyInfo().getSignersCertificate().getSubjectDN().getName());
		    	String name = sdoc.getSignature(i).getKeyInfo().getSubjectLastName();
		    	String date = sdoc.getSignature(i).getSignedProperties().getSigningTime().toString();
		    	String certificateSerial = sdoc.getSignature(i).getKeyInfo().getSignersCertificate().getSerialNumber().toString();
		    	String validFrom = sdoc.getSignature(i).getKeyInfo().getSignersCertificate().getNotBefore().toLocaleString();
		    	String validUntil = sdoc.getSignature(i).getKeyInfo().getSignersCertificate().getNotAfter().toLocaleString();
		    	String certificateIssuer = sdoc.getSignature(i).getKeyInfo().getSignersCertificate().getIssuerX500Principal().toString();
		    	
		    	// agregar el nombre comun del firmante y la fecha y la hora
		    	signers.add(new SignerFromBDOC(name, cn, date, certificateSerial, validFrom, validUntil, certificateIssuer));
		    	
		    }
		    SignerFromBDOCAdapter signerAdapter = new SignerFromBDOCAdapter(BDOCVerifyResultActivity.this, signers);
		    signerListView.setAdapter(signerAdapter);
		    signerListView.setOnItemClickListener(new android.widget.AdapterView.OnItemClickListener() {

		    	
				@Override
				public void onItemClick(AdapterView<?> parent, View view,
						int position, long id) {
					
					//String signer = parent.getItemAtPosition(position).toString();
					
					Toast.makeText(getApplicationContext(), "SE DEBE MOSTRAR INFORMACIÓN DEL FIRMANTE", Toast.LENGTH_SHORT).show();
					showSignatureDetails(position, signers);
				}
				
			});
		    
		    
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			
			//showOneButtonDialog(e.getMessage());
			
			Log.d("****exception:", e.getMessage());					
			e.printStackTrace();	
		}
		
	} // fin de doVerification(String f)
	
	
	
	

	
	
	
	

	// clase que abstrae un documento incluido dentro de un contenedor BDOC
	public class DocumentFromBDOC {
		private String mName;
		
		public DocumentFromBDOC(String name){
			mName = name;
		}
		
		public void setName(String name) {
			this.mName = name;
		}
		
		public String getName() {
			return mName;
		}	
	} // fin de clase DocumentFromBDOC
	
	// clase que abstrae el adaptador para llenar el ListView de documentos que
	// se encuentran dentro del contenedor BDOC
	private class DocumentFromBDOCAdapter extends BaseAdapter {

		private ArrayList<DocumentFromBDOC> mDocumentFromBDOCList;
		private LayoutInflater lInflater;
		
		private DocumentFromBDOCAdapter(Context context, ArrayList<DocumentFromBDOC> documents) {
			this.lInflater = LayoutInflater.from(context);
			this.mDocumentFromBDOCList = documents;
			
		}
		
		
		@Override
		public int getCount() {			
			return mDocumentFromBDOCList.size();
		}

		@Override
		public Object getItem(int position) {			
			return mDocumentFromBDOCList.get(position);
		}

		@Override
		public long getItemId(int position) {			
			return position;
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			ViewHolder container = null;
			
			if (convertView == null){
				container = new ViewHolder();
				convertView = lInflater.inflate(R.layout.document_inside_bdoc_item, null);
				
				container.filename_text = (TextView) convertView.findViewById(R.id.filename_text);
				container.filename_modified = (TextView) convertView.findViewById(R.id.filename_modified);
				container.type_image = (ImageView) convertView.findViewById(R.id.type_image);
				convertView.setTag(container);
			}else{
				container = (ViewHolder) convertView.getTag();
			}
			
			DocumentFromBDOC doc = (DocumentFromBDOC) getItem(position);
			container.filename_text.setText(doc.getName());
			container.filename_modified.setText(doc.getName());
			container.type_image.setImageResource(R.drawable.ic_archivo);
			
			return convertView;
		}
	
		
		class ViewHolder{
		      TextView filename_text;
		      TextView filename_modified;
		      ImageView type_image;
		   }
		
	}
	
	
	// class que abstrae un firmante incluido en un contenedor BDOC
	private class SignerFromBDOC {
		
		// nombre del firmante
		private String mName;
		
		// nombre comun del firmante
		private String mCN;
		
		// fecha y hora de la firma
		private String mDate;
		
		// serial del certificado
		private String mCertificateSerial;
		
		// fecha de validez inicial
		private String mValidFrom;
		
		// fecha de validez final
		private String mValidUntil;
		
		// emisor del certificado
		private String mCertificateIssuer;
		
		public SignerFromBDOC(String name, String cn, String date, String serial, String validFrom, String validUntil, String issuer){
			mName = name;
			mCN = cn;
			mDate = date;
			mCertificateSerial = serial;
			mValidFrom = validFrom;
			mValidUntil = validUntil;
			mCertificateIssuer = issuer;			
		}
		
		public void setName(String name) {
			this.mName = name;
		}
		
		public String getName() {
			return mName;
		}	
		
		public void setCN(String cn) {
			this.mCN = cn;
		}
		
		public String getCN() {
			return mCN;
		}		
		
		public void setDate(String date) {
			this.mDate = date;
		}
		
		public String getDate() {
			return mDate;
		}
		
		public void setCertificateSerial(String certSerial) {
			this.mCertificateSerial = certSerial;
		}
		
		public String getCertificateSerial() {
			return mCertificateSerial;
		}
		
		public void setValidFrom(String validFrom) {
			this.mValidFrom = validFrom;
		}
		
		public String getValidFrom() {
			return mValidFrom;
		}
		
		public void setValidUntil(String validUntil) {
			this.mValidUntil = validUntil;
		}
		
		public String getValidUntil() {
			return mValidUntil;
		}
		
		public void setCertificateIssuer(String certIssuer) {
			this.mCertificateIssuer = certIssuer;
		}
		
		public String getCertificateIssuer() {
			return mCertificateIssuer;
		}
		
	} // fin de clase SignerFromBDOC
	
	// clase que abstrae el adaptador para llenar el ListView de documentos que
	// se encuentran dentro del contenedor BDOC
	private class SignerFromBDOCAdapter extends BaseAdapter {

		private ArrayList<SignerFromBDOC> mSignerFromBDOCList;
		private LayoutInflater lInflater;
		
		private SignerFromBDOCAdapter(Context context, ArrayList<SignerFromBDOC> signers) {
			this.lInflater = LayoutInflater.from(context);
			this.mSignerFromBDOCList = signers;
			
		}
		
		
		@Override
		public int getCount() {			
			return mSignerFromBDOCList.size();
		}

		@Override
		public Object getItem(int position) {			
			return mSignerFromBDOCList.get(position);
		}

		@Override
		public long getItemId(int position) {			
			return position;
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			ViewHolder container = null;
			
			if (convertView == null){
				container = new ViewHolder();
				convertView = lInflater.inflate(R.layout.signer_inside_bdoc_item, null);
				
				container.signer_text = (TextView) convertView.findViewById(R.id.signer_info);
				container.signer_modified = (TextView) convertView.findViewById(R.id.signature_errors);
				container.type_image = (ImageView) convertView.findViewById(R.id.type_image);
				convertView.setTag(container);
			}else{
				container = (ViewHolder) convertView.getTag();
			}
			
			SignerFromBDOC doc = (SignerFromBDOC) getItem(position);
			container.signer_text.setText(doc.getName());
			container.signer_modified.setText(doc.getName());
			container.type_image.setImageResource(R.drawable.ic_pluma);
			
			return convertView;
		}
	
		
		class ViewHolder{
		      TextView signer_text;
		      TextView signer_modified;
		      ImageView type_image;
		   }
		
	}
	
	
	/**
     * Prepara directorio
     * @return boolean
     */
    private boolean prepareDirectory() 
    {
        try
        {
            if (makedirs()) 
            {
                return true;
            } else {
                return false;
            }
        } catch (Exception e) 
        {
            e.printStackTrace();
            Toast.makeText(this, "Could not initiate File System.. Is Sdcard mounted properly?", Toast.LENGTH_LONG).show();
            return false;
        }
    }
 
    /**
     * Crea directorio utilizando la variable tmpDir
     * @return boolean
     */
    private boolean makedirs() 
    {
        File tempdir = new File(extractedDirFiles);
        if (!tempdir.exists())
            tempdir.mkdirs();
 
//        if (tempdir.isDirectory()) 
//        {
//            File[] files = tempdir.listFiles();
//            for (File file : files) 
//            {
//                if (!file.delete()) 
//                {
//                    System.out.println("Failed to delete " + file);
//                }
//            }
//        }
        return (tempdir.isDirectory());
    }
	
    // funcion para lanzar un intent que abra un archivo
    private void openIt(String filePath, String mimeType) {
		
		Intent shareIntent = new Intent();
		shareIntent.setAction(Intent.ACTION_VIEW);
		File file = new File(filePath);
		Uri uri = Uri.fromFile(file);
		Log.i("DEBUG", file.getPath());
		shareIntent.setDataAndType(uri, mimeType);		
		startActivity(Intent.createChooser(shareIntent, getResources().getText(R.string.open_it_using)));
	}
    
    // funcion para obtener el tipo mime de un archivo
    public static String getMimeType(String url)
    {
        String extension = url.substring(url.lastIndexOf("."));
        String mimeTypeMap = MimeTypeMap.getFileExtensionFromUrl(extension);
        String mimeType = MimeTypeMap.getSingleton().getMimeTypeFromExtension(mimeTypeMap);
        return mimeType;
    }
    
    // funcion para compartir el documento
	private void shareIt() {
		
		Intent shareIntent = new Intent();
		shareIntent.setAction(Intent.ACTION_SEND);
		File file = new File(fileToVerify);
		
		
		Uri uri = Uri.fromFile(file);
		Log.i("DEBUG", file.getPath());
		//Log.d("******", getMimeType(file.getPath()));
		//shareIntent.setDataAndType(uri, getMimeType(file.getPath()));
		shareIntent.putExtra(Intent.EXTRA_STREAM, uri);
		shareIntent.setType("application/*");
		startActivity(Intent.createChooser(shareIntent, getResources().getText(R.string.share_it_using)));
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.bdocverify_result, menu);
		return true;
	}
    
	private void showSignatureDetails(int position, ArrayList<SignerFromBDOC> signers) {
		
		Log.d("**showSignatureDetails", Integer.toString(position));
		Log.d("** nombre", signers.get(position).getName());
		Intent intent = new Intent(this, ActivitySignerInfo.class);
		
		intent.putExtra("name", signers.get(position).getName());
		intent.putExtra("cn", signers.get(position).getCN());
		intent.putExtra("date", signers.get(position).getDate());
		intent.putExtra("certificateSerial", signers.get(position).getCertificateSerial());
		intent.putExtra("validFrom", signers.get(position).getValidFrom());
		intent.putExtra("validUntil", signers.get(position).getValidUntil());
		intent.putExtra("certificateIssuer", signers.get(position).getCertificateIssuer());
		startActivity(intent);
	}
	
	// funcion para desplegar la interfaz con los detalles de errores de la firma
	private void showSignatureDetails() {
		Log.d("showSignatureDetails()", "...");
	}
	
	/**
     * Showing Dialog for downloading file
     * */
    @Override
    protected Dialog onCreateDialog(int id) {
        switch (id) {
        case progress_bar_type: // we set this to 0
            pDialog = new ProgressDialog(this);
            pDialog.setMessage("Downloading file. Please wait...");
            pDialog.setIndeterminate(false);
            pDialog.setMax(100);
            pDialog.setProgressStyle(ProgressDialog.STYLE_HORIZONTAL);
            pDialog.setCancelable(true);
            pDialog.show();
            return pDialog;
        default:
            return null;
        }
    }
	
	// clase para descargar archivo
	private class DownloadFileFromURL extends AsyncTask<String, String, String> {

		
		/**
         * Before starting background thread
         * Show Progress Bar Dialog
         * */
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            showDialog(progress_bar_type);
        }
		
		
        /**
         * Downloading file in background thread
         * */
        @Override
        protected String doInBackground(String... f_url) {
            
        	// para solventar error:
        	// Can't create handler inside thread that has not called Looper.prepare()
        	Looper.prepare();
        	
        	int count;
            
            String outputString = null;
            try {
            	Toast.makeText(getApplicationContext(), "doInBackground", Toast.LENGTH_SHORT).show();
            	Log.d("doInBackground", "log");
            	
                URL url = new URL(f_url[0]);
                //URLConnection conection = url.openConnection();
                HttpURLConnection conection = (HttpURLConnection) url.openConnection();
                conection.connect();
                
                
                
                // this will be useful so that you can show a tipical 0-100% progress bar
                int lenghtOfFile = conection.getContentLength();
 
                // download the file
                //InputStream input = new BufferedInputStream(url.openStream(), 8192);
                InputStream input = new BufferedInputStream(url.openStream());
 
                
                File rootDir = Environment.getExternalStorageDirectory();
                // Output stream
                //OutputStream output = new FileOutputStream("/sdcard/downloaded.jpg");
                OutputStream output = new FileOutputStream(new File(rootDir+"/TibisayMovil/", "descarga.bdoc"));
 
                byte data[] = new byte[1024];
 
                long total = 0;
 
                while ((count = input.read(data)) != -1) {
                    total += count;
                    // publishing the progress....
                    // After this onProgressUpdate will be called
                    publishProgress(""+(int)((total*100)/lenghtOfFile));
 
                    // writing data to file
                    //output.write(data, 0, count);
                }
 
                // flushing output
                output.flush();
 
                // closing streams
                output.close();
                
                input.close();
                
 
            } catch (Exception e) {
                
            	Log.e("Error: ", e.getMessage());
            	outputString = e.getMessage();
            	
                
            }
 
            //return null;
            return outputString;
            
        }
        
        /**
         * Updating progress bar
         * */
        protected void onProgressUpdate(String... progress) {
            // setting progress percentage
            pDialog.setProgress(Integer.parseInt(progress[0]));
        }
        
        /**
         * After completing background task
         * Dismiss the progress dialog
         * **/
        @Override
        protected void onPostExecute(String file_url) {
            // dismiss the dialog after the file was downloaded
            dismissDialog(progress_bar_type);
 
            // Displaying downloaded image into image view
            // Reading image path from sdcard
            //String filePath = Environment.getExternalStorageDirectory().toString() + "/TibisayMovil" +"/downloaded.bdoc";
            Toast.makeText(getApplicationContext(), "onPostExecute "  , Toast.LENGTH_SHORT).show();
            Toast.makeText(getApplicationContext(), file_url  , Toast.LENGTH_LONG).show();
            // setting downloaded into image view
            //my_image.setImageDrawable(Drawable.createFromPath(imagePath));
        }
        
			
		
	}
	


		
	
}




